/*     

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   IpAddr
inline bool operator==( const IpAddr& ip1, const IpAddr& ip2 ) { return ip1.S_un.S_addr == ip2.S_un.S_addr; }
_KERNEL bool operator>=( const IpAddr& ip1, const IpAddr& ip2 );

//    
class CBan
{

public: //   

	//  
	_KERNEL void InitNew();

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	_KERNEL bool operator==( const CBan& b ) const { return m_ip == b.m_ip; }
	_KERNEL bool operator>=( const CBan& b ) const { return m_ip >= b.m_ip; }

public: // 

	// IP   
	_KERNEL const char* ipText() const { return IPAsStr( m_ip ); }

	//   IP
	_KERNEL void parseIPText( const char* ipText );

	//    IP   
	_KERNEL bool in( IpAddr ip ) const;

public: // 

	IpAddr m_ip;       // IP
	CString m_desc;     // 
	CAccount* m_admin;  // 

	//    ()
	char m_creater[MAX_ACCOUNT_NAME+1];

	SPSet<CAccount*> m_access; //   

};
