/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
class CBoardMessage
{

public: //   

	//  
	_KERNEL void InitNew();

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	char m_author[CHAR_NAME_SIZE+1]; // 
	time_t m_time;                   //  

	CString m_title;  // 
	CString m_text;   // 

};

// 
class CBoard
{

public: //   

	//  
	_KERNEL void InitNew();

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	//  
	_KERNEL bool isFull() { return m_messages.getCount() >= 500; }

	//  
	_KERNEL void UpdateView();

	//  
	_KERNEL void AddMessage( CBoardMessage* msg );

	//    
	_KERNEL void DeleteMessage( int idx );

public: // 

	int m_id; //  
	Array<CBoardMessage*> m_messages; // 

	char m_view[0xFFFF]; //   ,  

};
