/*   
	Copyright (c) 2012. All Rights Reserved.
	: 
*/
#pragma once
#include "Main.h"

//   
class CAIData
{

public: // 

	byte m_act; // 
	bool (CCharMob::*m_func) ( FightSituation& ); // 

};

//   
class CAIAttackData
{

public: // 

	byte m_act; // 
	bool (CCharMob::*m_func) ( CChar* ); // 

};

//    
class CAINode
{

public: // 

	byte m_type; // 
	int m_perc;  // 

};

//    
class CAIAttackNode
{

public: // 

	byte m_type; // 
	int m_perc;  // 

};

//  
class CProfAI
{

public: // 

	CProfAI() {}

	CProfAI( int id ) :
		m_id( id )
	{}

public: // 

	//  
	static void InitTable();

	//   
	_KERNEL void Serialize( CFileStore& fs );

	//   
	_KERNEL void AddAINodeTable( PArray<CAINode>* nodes, CAINode* table, int size );

	//   
	_KERNEL void AddAttackTable( PArray<CAIAttackNode>* nodes, CAIAttackNode* table, int size );

public: // 

	//    
	static CAIData m_aiActs[AI_COUNT];

	//    
	static CAIAttackData m_aiAttacks[AIA_COUNT];

public: // 

	int m_id;                        // 

	CString m_name;                  // 

	PArray<CAINode> m_lookNodes;     //  LookAI
	PArray<CAINode> m_standNodes;    //  StandAI
	PArray<CAINode> m_fightNodes;    //  FightAI
	PArray<CAIAttackNode> m_attacks; // 

};
