/*   

	Copyright (c) 2011. All Rights Reserved.
	: 
*/

#pragma once

class CRuneInfo;

//  
class CRuneSlot
{

public: //   

	CRuneSlot( const CRuneInfo* rune, RuneNode node, uint life );
	~CRuneSlot();

public: // 

	const CRuneInfo* m_rune; //   
	byte m_node;             //  
	int m_level;             //  
	uint m_lifePulse;        //   

	CString m_name[6];       //    
	CString m_mask;          // 

	int m_weight;            // 
	CMaterial* m_material;   // 
	int m_flags;             // 
	uint m_timer;            // 

	int m_modifierCount;     //  
	CModifier** m_modifiers; // 

	CAffect* m_affect;       // 

};
