/*    

	Copyright (c) 2016. All Rights Reserved.
	:  ..
*/
#pragma once

const byte s_maxZoneLevel = 45;

//  
class CWeakenParams
{

public: // 

    double m_koefs[WKT_COUNT];  //  

};

//   
class CWeakenBase
{

public: // 

    // 
    _KERNEL void Init();

    //   
    _KERNEL void SetZoneParams();

    //  
    _KERNEL double GetKoef( int type, int level );

    //  
    _KERNEL CWeakenParams* GetParams( int level );

    //   
    _KERNEL void WeakenSpecial();

private: // 

    //  
    double m_weakenKoefs[s_maxZoneLevel][WKT_COUNT];
};
