/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
const int MAX_CMD_LENGTH = 250;

//  
class CCmdText
{

public: // , 

	CCmdText( const char* text, CCmdText* next = NULL )
	{
		int len = strlen( text );
		if( len > MAX_CMD_LENGTH )
			len = MAX_CMD_LENGTH;
		m_text = new char[len+1];
		strncpy( m_text, text, len );
		m_text[len] = '\0';
		m_next = next;
	}

	~CCmdText()
	{
		delete m_text;
	}

public: // 

	char* m_text;   //  
	CCmdText* m_next;  //  

};

//  
class CCmdQuery
{

public: //  

	CCmdQuery() : m_begin( NULL ), m_end( NULL ) {}

public: // 

	//  
	bool IsEmpty() { return m_begin == NULL; }

	//   
	_KERNEL void Add( CCmdText* cmd );

	//    
	_KERNEL CCmdText* GetFromQuery();

	//  
	_KERNEL void Clear();

public: // 

	CCmdText* m_begin; //  
	CCmdText* m_end;   //  

};
