/*     
	Copyright (c) 2011. All Rights Reserved.
	: .
*/
#pragma once

//    
class CFileEntry
{

public: // 

	_KERNEL CFileEntry() :
		m_fileData( NULL )
	{}

public: // 

	//  
	_KERNEL char* name();

	//  
	_KERNEL bool isType( char* type );

	//  
	_KERNEL bool isDirectory();

	//   
	_KERNEL void getData( time_t& time );

	//    
	_KERNEL static void CreatePath( char*& path, char* lastName, char* dir1 = NULL, char* dir2 = NULL, char* dir3 = NULL );

	//    
	_KERNEL static void Init();

	// 
	_KERNEL static const char* Slash();

public: // 

	_KERNEL static char* m_dirBackup;     //  
	_KERNEL static char* m_dirDB;         //  
	_KERNEL static char* m_dirZone;       //  
	_KERNEL static char* m_dirInst;       //  
	_KERNEL static char* m_dirDeleted;    //  
	_KERNEL static char* m_dirAccount;    //  
	_KERNEL static char* m_dirChar;       //  
	_KERNEL static char* m_dirLog;        //  
	_KERNEL static char* m_dirLogMask;    //    

	_KERNEL static char* m_fileNews;      //  
	_KERNEL static char* m_fileDB;        //   
	_KERNEL static char* m_fileDBBak;     //  
	_KERNEL static char* m_fileDBBakMask; //   
	_KERNEL static char* m_fileCrash;     //  
	_KERNEL static char* m_fileBookInit;  //   
	_KERNEL static char* m_fileBoardInit; //    
	_KERNEL static char* m_fileAnnounce;  //  
	_KERNEL static char* m_fileAccMask;   //    
	_KERNEL static char* m_fileCharMask;  //    
	_KERNEL static char* m_fileZones;     //  
	_KERNEL static char* m_fileLegend;    //  
	_KERNEL static char* m_fileSocial;    //  
	_KERNEL static char* m_fileBug;       //  
	_KERNEL static char* m_fileMisprint;  //  
	_KERNEL static char* m_fileIdea;      //  
	_KERNEL static char* m_fileHelp;      //  
	_KERNEL static char* m_fileIni;       //  
	_KERNEL static char* m_fileBot;       //   
	_KERNEL static char* m_fileServerLog; //   
	_KERNEL static char* m_fileTellsLog;  //   

	_KERNEL static char* m_pathCrash;          // :  
	_KERNEL static char* m_pathBookInit;       // :   
	_KERNEL static char* m_pathBoardInit;      // :    
	_KERNEL static char* m_pathAnnounce;       // :  
	_KERNEL static char* m_pathDirBackup;      // :  
	_KERNEL static char* m_pathDirDeleted;     // :  
	_KERNEL static char* m_pathDirDeletedAcc;  // :  
	_KERNEL static char* m_pathDirDeletedChar; // :  
	_KERNEL static char* m_pathDB;             // :  
	_KERNEL static char* m_pathDirZone;        // :  
	_KERNEL static char* m_pathDirInst;        // :  
	_KERNEL static char* m_pathZoneFile;       // :  
	_KERNEL static char* m_pathDirDB;          // :   
	_KERNEL static char* m_pathDBBak;          // :  
	_KERNEL static char* m_pathNews;           // :  
	_KERNEL static char* m_pathZones;          // :  
	_KERNEL static char* m_pathAccMask;        //     
	_KERNEL static char* m_pathCharMask;       //     
	_KERNEL static char* m_pathLegend;         // :  
	_KERNEL static char* m_pathSocial;         // :  
	_KERNEL static char* m_pathHelp;           // :  
	_KERNEL static char* m_pathAccFile;        // :  
	_KERNEL static char* m_pathCharFile;       // :  
	_KERNEL static char* m_pathIni;            // :  
	_KERNEL static char* m_pathBot;            // :   
	_KERNEL static char* m_pathServerLog;      // :   
	_KERNEL static char* m_pathTellsLog;       // :   
	_KERNEL static char* m_pathDirLog;         // :  
	_KERNEL static char* m_pathLogMask;        //     
	_KERNEL static char* m_pathZoneMask;       //     
	_KERNEL static char* m_pathInstMask;       //     
	_KERNEL static char* m_pathDirDeletedAccMask;  //      
	_KERNEL static char* m_pathDirDeletedCharMask; //      
	_KERNEL static char* m_pathBackupFile;     // :  

	_KERNEL static char* m_extZone; // : 
	_KERNEL static char* m_extTrig; // : 
	_KERNEL static char* m_extDat;  // : 

public: // 

	void* m_fileData; //   

};

//  
_KERNEL bool findFile( CFileEntry& file, const char* dirName, const char* fileName );

//  
_KERNEL bool scanDir( CFileEntry& file, CFileEntry*& dir, const char* dirName, const char* fileMask = NULL );

//  
_KERNEL bool copyFile( char* srcName, char* fileName, char* newPath, bool toDelete = false );

//  
_KERNEL bool copyDir( char* srcName, char* destName, bool toDelete = false );
