/*    

	Copyright  1999. All Rights Reserved.
	:  ..
*/
#pragma once

//   
template <class T> void ListInsert( T*& list, T* item )
{
	try {

	//   !!!!!!!!!!
	if( ListFind( list, item )  )
	{
		//  
		g_log.SystemLog( "SYSERR:    !" );
		*(int*)0 = 666;
	}

	item->m_next = list;
	list = item;

	} catch(...) { g_log.SystemLog( "Catch: ListInsert" ); throw; }
}

//    ( )
template <class T> void ListInsertLast( T*& list, T* item )
{
	try {

	//   
	item->m_next = NULL;

	//   
	if( list )
	{
		//   
		T* lastItem; for( lastItem = list; lastItem->m_next; lastItem = lastItem->m_next );

		//   
		lastItem->m_next = item;
	}
	else list = item;

	} catch(...) { g_log.SystemLog( "Catch: ListInsertLast" ); throw; }
}

//   
template <class T> void ListRemove( T*& list, T* item )
{
	try {

	//    
	if( list )
	{
		//   
		if( list == item )
		{
			//    
			list = (T*)list->m_next;

			//     ()
			item->m_next = NULL;
		}
		else
		{
			//   
			T* temp = list;
			while( temp->m_next && (T*)temp->m_next != item )
				temp = (T*)temp->m_next;

			//  
			if( temp->m_next )
			{
				//    
				temp->m_next = temp->m_next->m_next;

				//     ()
				item->m_next = NULL;
			}
		}
	}

	} catch(...) { g_log.SystemLog( "Catch: ListRemove" ); throw; }
}

//   
template <class T> T* ListFind( T* list, T* item )
{
	try {

	for( T* i = list; i; i = (T*)i->m_next )
		if( i == item ) return i;
	return NULL;

	} catch(...) { g_log.SystemLog( "Catch: ListFind" ); throw; }
}

//   
template <class T> int ListCount( T* list )
{
	try {

	int count = 0;
	for( T* li = list; li; li = (T*)li->m_next ) count++;
	return count;

	} catch(...) { g_log.SystemLog( "Catch: ListCount" ); throw; }
}
