/*     

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//    
class CMaskManager
{

public: // 

	_KERNEL CMaskManager() {}
	_KERNEL CMaskManager( char* srcMask ) { Init( srcMask ); }

public: // 

	// 
	_KERNEL void Init( char* srcMask );

	//  
	_KERNEL bool Compare( const char* text );

	//       
	_KERNEL bool CompareFull( const char* text, bool exact = false, int* pDiff = NULL );

public: // 

	bool m_all;              //   ''
	bool m_me;               //   ''
	int  m_allCount;         //     '5'

	const char* m_mask;      // 
	int m_num;               //  
	int m_maskCount;         //    

};

//     
_KERNEL void MaskFormat( char* text );
