/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

inline char* StrAlloc( const char* str ) { char* s = new char[strlen(str)+1]; strcpy( s, str ); return s; }

// 
class CString
{

public: // , 

	_KERNEL CString( const char* str = NULL );
	_KERNEL ~CString();
	_KERNEL CString( const CString& );
	_KERNEL CString& operator=( const CString& );

public: // 

	// 
	_KERNEL bool isNull() { return !m_str; }

	// 
	_KERNEL void Clean();

	//  
	_KERNEL operator const char*() const { return m_str; }

	// 
	_KERNEL CString& operator=( const char* str );

public: //  

	_KERNEL bool operator==( const char* str ) const { return strcmp( m_str, str ) == 0; }
	_KERNEL bool operator!=( const char* str ) const { return strcmp( m_str, str ) != 0; }
	_KERNEL bool operator>=( const char* str ) const { return strcmp( m_str, str ) >= 0; }
	_KERNEL bool operator<=( const char* str ) const { return strcmp( m_str, str ) <= 0; }
	_KERNEL bool operator> ( const char* str ) const { return strcmp( m_str, str ) >  0; }
	_KERNEL bool operator< ( const char* str ) const { return strcmp( m_str, str ) <  0; }

public: // 

	char* m_str; // 

};
