/*   

	Copyright (c) 2016. All Rights Reserved.
	:  ..
*/
#pragma once

//    
class CGroupSearchNode
{

public: //   

    CGroupSearchNode( CCharPlayer* cp = NULL, bool leader = false, const char* comment = NULL );

public: // 

    //  
    void Init( CCharPlayer* cp, bool leader, const char* comment );

public: // 

    CCharPlayer* m_char;    // 
    uint m_exitPulse;       //    
    bool m_leader;          // 
    CString m_comment;      // 

};

//   
class CGroupSearchBase
{

public: // 

    //    
    int FindChar( CCharPlayer* cp );

    //    
    void AddChar( CCharPlayer* cp, bool isLeader, const char* comment, bool noMsg = true );

    //    
    void CheckAddChar( CCharPlayer* cp );

    //    
    void RemoveChar( CCharPlayer* cp, bool noMsg = true );

    //   
    void Inform( CGroupSearchNode* node );

    //   
    void SetExitPulse( CCharPlayer* cp, bool reset = false );

    //   
    void CheckExitPulse();

public: // 

    PArray<CGroupSearchNode*> m_list; //  

};