/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once
#include "Main.h"
#include "DB/Char/ProfAI.h"

// 
class CProfession
{

public: // 

	_KERNEL CProfession();

public: // 

	//   
	_KERNEL static void InitTable( CProfession* profs[] );

public: // 

	//   
	_KERNEL void Apply( CChar* c, PkFlag pkFlag );

	//  
	_KERNEL const char* text( int i = 0 ) { return (const char*)m_text[i]; }

	//   
	_KERNEL virtual bool CheckMask( CMaskManager& mm ) { return mm.Compare( m_mask ); }

public: // 

	byte  m_id;       //  
	int   m_bit;      //  
	char* m_name;     //  
	char* m_text[6];  //  
	char* m_flagName; //   
	char* m_mask;     //  

	double m_hpK;   //   
	double m_manaK; //   
	double m_mvK;   //   

	int m_str;      //  
	int m_int;      //  
	int m_wiz;      //  
	int m_dex;      //  
	int m_con;      //  

	int m_resist[MS_COUNT];       //  

	double m_weaponK[12];         //   
	byte*  m_startWeapons;        // ,    

	double m_skillK[SKILL_COUNT];  //   
	bool   m_skillMe[SPELL_COUNT]; //     
	byte*  m_startSkills;          // ,    

	double m_spellK[SPELL_COUNT];  //   
	bool   m_spellMe[SPELL_COUNT]; //     
	byte*  m_startSpells;          // ,    

	bool m_enabled;  //    
	bool m_farFight; //   
	bool m_caster;   //  - 

	int  m_bashK;      //   
	int  m_disarmK;    //   
	int  m_silenceK;   //   
	int  m_blindK;     //   
	int  m_holdK;      //   
	int  m_manaDrainK; //    

	int  m_sealNear;   //     
	int  m_sealFar;    //     

	CProfAI* m_profAI; //   

};
