/*  

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

// 
class CRace
{

public: // 

	_KERNEL CRace();

public: // 

	//   
	_KERNEL static void InitTable( CRace* rases[] );

	//   
	_KERNEL virtual void Apply( CChar* cl, PkFlag pkFlag ) {}

	//   
	char* name( Gender g = GENDER_MALE ) { return m_name[g == GENDER_FEMALE ? 1 : 0]; }

	//     
	char* form( int i, Gender g ) { return m_forms[g == GENDER_FEMALE ? 1 : 0][i]; }

	// 
	_KERNEL virtual bool isHumanoid() { return true; }

    //  
    _KERNEL virtual bool HasAutoAffect( ushort affId ) { return false; }

public: // 

	byte  m_id;          //  
	int   m_bit;         //  

protected:

	char* m_name[2];     //   (   )
	char* m_forms[2][6]; //  (   )

public:

	byte m_type;    //  

	char* m_flagName; //   

	byte m_str;     // 
	byte m_int;     // 
	byte m_wiz;     // 
	byte m_dex;     // 
	byte m_con;     // 
	byte m_size;    // 

	byte m_magic[2]; //  

	double m_weaponK[12]; //   
	double m_skillK[SKILL_COUNT]; //   
	double m_spellK[SPELL_COUNT]; //   

	short m_magicResist[MS_COUNT];  //  

};
