/*   

	Copyright (c) 2015. All Rights Reserved.
	: 
*/
#pragma once

//  
class CResistInfo
{

public: // 

	CResistInfo( const char* name, const char* mask, const char* shortName, int resId, int modId ) :
		m_name( name ), m_mask( mask ), m_shortName( shortName ), m_resistId( resId ), m_modId( modId )
	{}

public: // 

	//   
	_KERNEL static void Init( CResistInfo* resists[] );

    //  
    _KERNEL const char* name( int type, bool mask = false, bool capital = false );

public: // 

	const char* m_name;      // 
	const char* m_mask;      // 
    const char* m_shortName; //  
	int m_resistId;          // 
	int m_modId;             // 

};
