/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//   
enum ColorID
{
	COLOR_0 = 0,  //  
	COLOR_0_30,   // 
	COLOR_0_31,   // 
	COLOR_0_32,   // 
	COLOR_0_33,   // 
	COLOR_0_34,   // 
	COLOR_0_35,   // 
	COLOR_0_36,   // 
	COLOR_0_37,   //  
	COLOR_1_30,   //  
	COLOR_1_31,   //  
	COLOR_1_32,   //  
	COLOR_1_33,   //  
	COLOR_1_34,   //  
	COLOR_1_35,   //  
	COLOR_1_36,   //  
	COLOR_1_37,   // 
	COLOR_COUNT
};

//   
class CColor
{

public: // 

	//  
	_KERNEL static void InitTable( CColor* colors[] );

public: // 

	ColorID m_id;      // 
	char*   m_name;    //  
	char*   m_mask;    // 
	char*   m_colorPrefix; //  
	char*   m_colorName;   //  

};

//   
enum ColorItemID
{
	CI_LOOK_ROOM_TITLE = 0,   //     ''
	CI_SCAN_ROOM_TITLE,       //     ''
	CI_EXITS_ROOM_TITLE,      //     ''
	CI_EXITS_ROOM_TITLE_DARK, //     '' ()
	CI_SUBJECT_IN_ROOM,       //     
	CI_ROOM_CHAR_IN_GROUP,    //   
	CI_ROOM_CHAR_PLAYER,      // -     (  )
	CI_ROOM_CHAR_MOB,         // -  

	CI_CHAT_CHAT,             // 
	CI_CHAT_HOLLER,           // 
	CI_CHAT_YELL,             // 
	CI_CHAT_SPEAK,            // 
	CI_CHAT_GSPEAK,           // 
	CI_CHAT_CSPEAK,           // 
	CI_CHAT_MY_TELL,          //   ,  
	CI_CHAT_OTHER_TELL,       //   ,  
	CI_CHAT_SOCIAL,           // 
	CI_CHAT_EMOTION,          // 

	CI_INCOME_CHAR_IN_GROUP,  //    
	CI_INCOME_CHAR_PLAYER,    //  -     (  )
	CI_INCOME_CHAR_MOB,       //  -  

	CI_OUTCOME_CHAR_IN_GROUP, //    
	CI_OUTCOME_CHAR_PLAYER,   //  -     (  )
	CI_OUTCOME_CHAR_MOB,      //  -  

	CI_CHAT_EXCHANGE,         //  
	CI_CHAT_AUCTION,          //  

	CI_MAGIC_CAST_ME,         //   
	CI_MAGIC_ASTRAL,          //    
	CI_MAGIC_MENTAL,          //    
	CI_MAGIC_LIFE,            //    
	CI_MAGIC_DEATH,           //    
	CI_MAGIC_FIRE,            //    
	CI_MAGIC_WATER,           //    
	CI_MAGIC_AIR,             //    
	CI_MAGIC_EARTH,           //    

	CI_ROOM_CHAR_PK,          //      
	CI_INCOME_CHAR_PK,        //    -   
	CI_OUTCOME_CHAR_PK,       //    -   

	CI_CHAT_WHISPER_MY,       // ,  
	CI_CHAT_WHISPER_OTHER,    // ,  
	/*
	CI_FLEE_CHAR_IN_GROUP,    //    
	CI_FLEE_CHAR_PLAYER,      //  -     (  )
	CI_FLEE_CHAR_MOB,         //  -  
	CI_FLEE_CHAR_PK,          //       

	CI_PORTAL_OUT_CHAR_IN_GROUP, //    
	CI_PORTAL_OUT_CHAR_PLAYER,   //  -     (  )
	CI_PORTAL_OUT_CHAR_MOB,      //  -  
	CI_PORTAL_OUT_CHAR_PK,       //       

	CI_PORTAL_IN_CHAR_IN_GROUP,  //    
	CI_PORTAL_IN_CHAR_PLAYER,    //  -     (  )
	CI_PORTAL_IN_CHAR_MOB,       //  -   (   )
	CI_PORTAL_IN_CHAR_PK,        //       
	*/
	CI_FIGHT_MY_KNOCK,           //    
	CI_FIGHT_MY_MISS,            //    
	CI_FIGHT_ENEMY_PARRY,        //    
	CI_FIGHT_ENEMY_KNOCK,        //    
	CI_FIGHT_ENEMY_MISS,         //    
	CI_FIGHT_MY_PARRY,           //    
	CI_FIGHT_MY_STUN,            //    
	CI_FIGHT_ENEMY_STUN,         //    

	CI_RIP_IN_GROUP,             //  
	CI_RIP_PLAYER,               //  -  
	CI_RIP_MOB,                  //  -
	CI_RIP_PK,                   //     

	CI_TAKE_CORPSE_MONEY,        //       
	CI_TAKE_CORPSE_SUBJECT,      //       

	CI_DELIMETR,                 //  

	CI_SKILL_WAR_CRY,            //    
	CI_SKILL_AREA_SHOT,          //    
	CI_SKILL_TRACK,              //   
	CI_SKILL_GRIND,              //   
	CI_SKILL_REPAIR,             //   

	CI_SKILL_BANDAGING1,         //    
	CI_SKILL_BANDAGING2,         //     
	CI_SKILL_BANDAGING3,         //     

	CI_SKILL_BACKSTAB1,          //     
	CI_SKILL_BACKSTAB2,          //     
	CI_SKILL_BACKSTAB3,          //      
	CI_SKILL_BACKSTAB4,          //      
	CI_SKILL_BACKSTAB5,          //      
	CI_SKILL_BACKSTAB6,          //      

	CI_SKILL_NEAT_SHOT1,         //      
	CI_SKILL_NEAT_SHOT2,         //      
	CI_SKILL_NEAT_SHOT3,         //       
	CI_SKILL_NEAT_SHOT4,         //       
	CI_SKILL_NEAT_SHOT5,         //       
	CI_SKILL_NEAT_SHOT6,         //       

	CI_SKILL_DISARM1,            //     
	CI_SKILL_DISARM2,            //     
	CI_SKILL_DISARM3,            //      
	CI_SKILL_DISARM4,            //      
	CI_SKILL_DISARM5,            //      
	CI_SKILL_DISARM6,            //      

	CI_SKILL_SWITCH1,            //     
	CI_SKILL_SWITCH2,            //     
	CI_SKILL_SWITCH3,            //      
	CI_SKILL_SWITCH4,            //      
	CI_SKILL_SWITCH5,            //      
	CI_SKILL_SWITCH6,            //      

	CI_SKILL_TRIP1,            //     
	CI_SKILL_TRIP2,            //     
	CI_SKILL_TRIP3,            //      
	CI_SKILL_TRIP4,            //      
	CI_SKILL_TRIP5,            //      
	CI_SKILL_TRIP6,            //      

	CI_SKILL_DRAW_ATTENTION1,  //      
	CI_SKILL_DRAW_ATTENTION2,  //      
	CI_SKILL_DRAW_ATTENTION3,  //       
	CI_SKILL_DRAW_ATTENTION4,  //       
	CI_SKILL_DRAW_ATTENTION5,  //       
	CI_SKILL_DRAW_ATTENTION6,  //       

	CI_SKILL_BASH1,            //      
	CI_SKILL_BASH2,            //      
	CI_SKILL_BASH3,            //       
	CI_SKILL_BASH4,            //       
	CI_SKILL_BASH5,            //       
	CI_SKILL_BASH6,            //       

	CI_SKILL_RESCUE1,          //     
	CI_SKILL_RESCUE2,          //     
	CI_SKILL_RESCUE3,          //      
	CI_SKILL_RESCUE4,          //      
	CI_SKILL_RESCUE5,          //      
	CI_SKILL_RESCUE6,          //      
	CI_SKILL_RESCUE7,          //      
	CI_SKILL_RESCUE8,          //      

	CI_SKILL_PUSH1,            //     
	CI_SKILL_PUSH2,            //     
	CI_SKILL_PUSH3,            //      
	CI_SKILL_PUSH4,            //      
	CI_SKILL_PUSH5,            //      
	CI_SKILL_PUSH6,            //      

	CI_SKILL_KICK1,            //      
	CI_SKILL_KICK2,            //      
	CI_SKILL_KICK3,            //       
	CI_SKILL_KICK4,            //       
	CI_SKILL_KICK5,            //       
	CI_SKILL_KICK6,            //       

	CI_SKILL_STEAL1,           //     
	CI_SKILL_STEAL2,           //     
	CI_SKILL_STEAL3,           //      
	CI_SKILL_STEAL4,           //      

	CI_AFF_HOLD1,              //   ''
	CI_AFF_HOLD2,              //   ''

	CI_AFF_ASTRAL_SHIELD1,     //   ' '
	CI_AFF_ASTRAL_SHIELD2,     //   ' '
	CI_AFF_BERSERK1,           //   ''
	CI_AFF_BERSERK2,           //   ''
	CI_AFF_BLESS1,             //   ''
	CI_AFF_BLESS2,             //   ''
	CI_AFF_WAR_CRY1,           //   ' '
	CI_AFF_VAMPIRISM1,         //   ''
	CI_AFF_VAMPIRISM2,         //   ''
	CI_AFF_SEE_AFFECTS1,       //   ' '
	CI_AFF_SEE_AFFECTS2,       //   ' '
	CI_AFF_SEE_MAGIC1,         //   ' '
	CI_AFF_SEE_MAGIC2,         //   ' '
	CI_AFF_SEE_INVIS1,         //   ' '
	CI_AFF_SEE_INVIS2,         //   ' '
	CI_AFF_ATTENTIVENESS1,     //   ''
	CI_AFF_ATTENTIVENESS2,     //   ''
	CI_AFF_SLOW1,              //   ''
	CI_AFF_SLOW2,              //   ''
	CI_AFF_NO_TRACK1,          //   ' '
	CI_AFF_NO_TRACK2,          //   ' '
	CI_AFF_DEFENCE1,           //   ''
	CI_AFF_DEFENCE2,           //   ''
	CI_AFF_PROTECTION_ASTRAL1, //   '  '
	CI_AFF_PROTECTION_ASTRAL2, //   '  '
	CI_AFF_PROTECTION_WATER1,  //   '  '
	CI_AFF_PROTECTION_WATER2,  //   '  '
	CI_AFF_PROTECTION_AIR1,    //   '  '
	CI_AFF_PROTECTION_AIR2,    //   '  '
	CI_AFF_PROTECTION_LIFE1,   //   '  '
	CI_AFF_PROTECTION_LIFE2,   //   '  '
	CI_AFF_PROTECTION_EARTH1,  //   '  '
	CI_AFF_PROTECTION_EARTH2,  //   '  '
	CI_AFF_PROTECTION_FIRE1,   //   '  '
	CI_AFF_PROTECTION_FIRE2,   //   '  '
	CI_AFF_PROTECTION_MENTAL1, //   '  '
	CI_AFF_PROTECTION_MENTAL2, //   '  '
	CI_AFF_PROTECTION_DEATH1,  //   '  '
	CI_AFF_PROTECTION_DEATH2,  //   '  '
	CI_AFF_INFRAVISION1,       //   ''
	CI_AFF_INFRAVISION2,       //   ''
	CI_AFF_STONE_SKIN1,        //   ' '
	CI_AFF_STONE_SKIN2,        //   ' '
	CI_AFF_STONE_ARROWS1,      //   ' '
	CI_AFF_STONE_ARROWS2,      //   ' '
	CI_AFF_FROST_ARMOR1,       //   ' '
	CI_AFF_FROST_ARMOR2,       //   ' '
	CI_AFF_COLD_ARROWS1,       //   ' '
	CI_AFF_COLD_ARROWS2,       //   ' '
	CI_AFF_MAGIC_AURA1,        //   ' '
	CI_AFF_MAGIC_AURA2,        //   ' '
	CI_AFF_LIGHT1,             //   ' '
	CI_AFF_LIGHT2,             //   ' '
	CI_AFF_MAGIC_SHIELD1,      //   ' '
	CI_AFF_MAGIC_SHIELD2,      //   ' '
	CI_AFF_MEDITATION1,        //   ''
	CI_AFF_MEDITATION2,        //   ''
	CI_AFF_SILENCE1,           //   ''
	CI_AFF_SILENCE2,           //   ''
	CI_AFF_INVISIBLE1,         //   ''
	CI_AFF_INVISIBLE2,         //   ''
	CI_AFF_FLAME_ARROWS1,      //   ' '
	CI_AFF_FLAME_ARROWS2,      //   ' '
	CI_AFF_FIRE_SHIELD1,       //   ' '
	CI_AFF_FIRE_SHIELD2,       //   ' '
	CI_AFF_FETTERS_DARKNESS1,  //   ' '
	CI_AFF_FETTERS_DARKNESS2,  //   ' '
	CI_AFF_OSSIFICATION1,      //   ''
	CI_AFF_OSSIFICATION2,      //   ''
	CI_AFF_SANCTUARY1,         //   ''
	CI_AFF_SANCTUARY2,         //   ''
	CI_AFF_FLY1,               //   ''
	CI_AFF_FLY2,               //   ''
	CI_AFF_CURSE1,             //   ''
	CI_AFF_CURSE2,             //   ''
	CI_AFF_REGENERATE1,        //   ''
	CI_AFF_REGENERATE2,        //   ''
	CI_AFF_STRENGTH1,          //   ''
	CI_AFF_STRENGTH2,          //   ''
	CI_AFF_WEAKNESS1,          //   ''
	CI_AFF_WEAKNESS2,          //   ''
	CI_AFF_DEMENTIA1,          //   ''
	CI_AFF_DEMENTIA2,          //   ''
	CI_AFF_BLINDNESS1,         //   ''
	CI_AFF_BLINDNESS2,         //   ''
	CI_AFF_DEATH_ARROWS1,      //   ' '
	CI_AFF_DEATH_ARROWS2,      //   ' '
	CI_AFF_SIZE1,              //   ''
	CI_AFF_SIZE2,              //   ''
	CI_AFF_LOW_SIZE1,          //   ''
	CI_AFF_LOW_SIZE2,          //   ''
	CI_AFF_HASTE1,             //   ''
	CI_AFF_HASTE2,             //   ''
	CI_AFF_SENSE_LIFE1,        //   ' '
	CI_AFF_SENSE_LIFE2,        //   ' '
	CI_AFF_MANA_SHIELD1,       //   ' '
	CI_AFF_MANA_SHIELD2,       //   ' '
	CI_AFF_POISON1,            //   ''
	CI_AFF_POISON2,            //   ''
	CI_AFF_RELAX1,             //   ''

	CI_FIGHT_MY_CRITICAL,      //     
	CI_FIGHT_ENEMY_CRITICAL,   //     

	CI_AFF_DRAIN_LEVEL1,       //   ' '
	CI_AFF_DRAIN_LEVEL2,       //   ' '

	CI_AFF_STONE_CURSE1,       //   ' '
	CI_AFF_STONE_CURSE2,       //   ' '

	CI_AFF_POLIMORPH1,         //   ''
	CI_AFF_POLIMORPH2,         //   ''

	CI_MAGIC_CAST_IN_GROUP,    //   
	CI_MAGIC_CAST_OTHER,       //    

	CI_FIGHT_ALLY_KNOCK,          //    
	CI_FIGHT_ALLY_CRITICAL,       //     
	CI_FIGHT_ALLY_MISS,           //    
	CI_FIGHT_ENEMY_PARRY_ALLY,    //    
	CI_FIGHT_ENEMY_KNOCK_ALLY,    //    
	CI_FIGHT_ENEMY_CRITICAL_ALLY, //     
	CI_FIGHT_ENEMY_MISS_ALLY,     //    
	CI_FIGHT_ALLY_PARRY,          //    

	CI_FIGHT_ALLY_STUN,           //    
	CI_FIGHT_ENEMY_STUN_ALLY,     //    

	CI_ROOM_TRACK_IN_GROUP,    //  
	CI_ROOM_TRACK_PLAYER,      //  -   (  )
	CI_ROOM_TRACK_MOB,         //  -
	CI_ROOM_TRACK_PK,          //     

	CI_SPELL_MY,               //    
	CI_SPELL_ENEMY,            //    
	CI_SPELL_ALLY,             //    
	CI_SPELL_ENEMY_ALLY,       //    

	CI_ROOM_AFF_LIGHT,         //       ''
	CI_ROOM_AFF_BLINDNESS,     //      ''
	CI_ROOM_AFF_SANCTUARY,     //      ''
	CI_ROOM_AFF_MAGIC_AURA,    //       ''
	CI_ROOM_AFF_ASTRAL_SHIELD, //       ''
	CI_ROOM_AFF_MAGIC_SHIELD,  //       ''
	CI_ROOM_AFF_FIRE_SHIELD,   //       ''
	CI_ROOM_AFF_STONE_SKIN,    //       ''
	CI_ROOM_AFF_MEDITATION,    //      ''

	CI_AFF_MISTING1,           //   ''
	CI_AFF_MISTING2,           //   ''

	CI_ROOM_AFF_MISTING,       //      ''

	CI_SKILL_POISON,           //   

	CI_POISON_ME,              //    
	CI_POISON_ALLY,            //    
	CI_POISON_OTHER,           //     
	CI_OBJECT_DESTROY,         //  

	CI_WEATHER,                //     

	CI_ROOM_AFF_HOLD,          //     ''

	CI_AFF_SEAL1,              //   ' '
	CI_AFF_SEAL2,              //   ' '

	CI_AFF_CONCENTRATION1,     //   ''
	CI_AFF_CONCENTRATION2,     //   ''

	CI_SPELL_MY_CRITICAL,            //      
	CI_SPELL_ENEMY_CRITICAL,         //      
	CI_SPELL_ALLY_CRITICAL,          //      
	CI_SPELL_ENEMY_ALLY_CRITICAL,    //      

	CI_SKILL_THROW1,         //     
	CI_SKILL_THROW2,         //     
	CI_SKILL_THROW3,         //      
	CI_SKILL_THROW4,         //      
	CI_SKILL_THROW5,         //      
	CI_SKILL_THROW6,         //      

	CI_SKILL_PICKLOCK1,            //     
	CI_SKILL_PICKLOCK2,            //     
	CI_SKILL_PICKLOCK3,            //      
	CI_SKILL_PICKLOCK4,            //      

	CI_SKILL_UNGRIND,            //   

	CI_AFF_RAGE0,           //   ' '
	CI_AFF_RAGE1,           //   ' '
	CI_AFF_RAGE2,           //   ' '
	CI_AFF_RAGE3,           //   ' '
	CI_AFF_RAGE4,           //   ' '

	CI_AFF_BLEEDING0,       //   ''
	CI_AFF_BLEEDING1,       //   ''
	CI_BLEEDING_ME,         //    
	CI_BLEEDING_ALLY,       //    
	CI_BLEEDING_OTHER,      //     

	CI_SQUEEZE_I,           //   ''"
	CI_SQUEEZE_ALLY,        //   ''"
	CI_SQUEEZE_OTHER,       //   ''"
	CI_SQUEEZE_ME,          //    ''"
	CI_SQUEEZE_TOALLY,      //    ''"

	CI_CHAT_NOOB,           //   

	CI_AFF_BLACK_MUTE1,     //    
	CI_AFF_BLACK_MUTE2,     //    

	CI_AFF_DISEASE1,        //  
	CI_AFF_DISEASE2,        //  

	CI_MIND_ME,             //     
	CI_MIND_ALLY,           //     
	CI_MIND_OTHER,          //      

	CI_AFF_CONGEST1,         //    
	CI_AFF_CONGEST2,         //    

	CI_AFF_BURNING1,         //   
	CI_AFF_BURNING2,         //   

	CI_AFF_HOLYBURNING1,         //    
	CI_AFF_HOLYBURNING2,         //    

	CI_AFF_FREEZE1,          //   
	CI_AFF_FREEZE2,          //   

	CI_AFF_SHOCK1,          //   
	CI_AFF_SHOCK2,          //   

	CI_AFF_COLL_MANA1,      //    

	CI_AFF_ANGER1,          //   

	CI_AFF_FRESHNESS1,      //   

	CI_SKILL_GET_PAIN,      //    

	CI_AFF_HOLYHUNTING1,    //    
	CI_AFF_HOLYHUNTING2,    //    

	CI_AFF_STANCE_ATTACK1,  //    
	CI_AFF_STANCE_ATTACK2,  //    

	CI_AFF_STANCE_DEFENCE1, //    
	CI_AFF_STANCE_DEFENCE2, //    

	CI_AFF_EYE_BURN1,       //    
	CI_AFF_EYE_BURN2,       //    

	CI_AFF_OBLIVION1,       //   
	CI_AFF_OBLIVION2,       //   

	CI_FIGHT_MY_MAGIC_STAFF,       //    
	CI_FIGHT_MY_ENEMY_MAGIC_STAFF, //      
	CI_FIGHT_ALLY_MAGIC_STAFF,     //    
	CI_FIGHT_ENEMY_MAGIC_STAFF,    //    

	CI_AFF_MAGIC_STAFF1,       //    
	CI_AFF_MAGIC_STAFF2,       //    

	CI_AFF_SHELTER_BODY1,      //   ' '
	CI_AFF_SHELTER_BODY2,      //   ' '

	CI_AFF_SHELTER_MIND1,      //   ' '
	CI_AFF_SHELTER_MIND2,      //   ' '

	CI_COUNT
};

//   
enum ColorGroupID
{
	CG_ROOMS = 0,  // 
	CG_CHATS,      //  
	CG_MOVE,       // 
	CG_MAGIC,      // 
	CG_FIGHT,      // 
	CG_SKILLS,     // 
	CG_AFFECTS,     // 
	CG_DIFERENT,   // 
	CG_COUNT
};

//   
class CColorItem
{

public: // 

	//  
	_KERNEL static void InitTable( CColorItem* items[] );

public: // 

	ColorItemID m_id;      // 
	char*       m_name;    //  
	ColorID     m_default; //  -

};

//   
class CColorGroup
{

public: // 

	CColorGroup( ColorGroupID id, char* name ) : m_id( id ), m_name( name ) {}

public: // 

	//  
	_KERNEL static void InitTable( CColorGroup* groups[] );

	//  
	void Add( int itemID );

public: // 

	ColorGroupID m_id;   //  
	char*        m_name; //  

	PArray<CColorItem*> m_items;  //  

};

