/*  

	Copyright (c) 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//    (  )
class CJournalRecord
{

public: // 

	time_t m_time;   //  
	byte m_count;    //   
	char m_text[1];  //  

};

// 
class CJournal
{

public: // 

	CJournal( int clrID, int maxSize ) :
		m_clrID( clrID ),
		m_maxSize( maxSize )
	{}

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	//  
	_KERNEL void AddRecord( const char* text );

public: // 

	int m_clrID;    //    
	int m_maxSize;  //  

	PArray<CJournalRecord*> m_records;  //  

};
