/*   

	Copyright (c) 2001 - 2004. All Rights Reserved.
	:  ..
*/
#pragma once

//  
class CTopic
{

public: //   

	//   
	_KERNEL void Serialize( CFileStore& fs );

public: // 

	CString m_keys;        //  
	CString m_text;        // 

};

//  
class CTopicKey
{

public: // 

	CTopicKey( const char* mask, CTopic* topic ) :
		m_mask( mask ),
		m_topic( topic )
	{}

public: //  

	bool operator==( const CTopicKey& k ) const { return m_mask == k.m_mask; }
	bool operator!=( const CTopicKey& k ) const { return m_mask != k.m_mask; }
	bool operator>=( const CTopicKey& k ) const { return m_mask >= k.m_mask; }
	bool operator<=( const CTopicKey& k ) const { return m_mask <= k.m_mask; }
	bool operator> ( const CTopicKey& k ) const { return m_mask >  k.m_mask; }
	bool operator< ( const CTopicKey& k ) const { return m_mask <  k.m_mask; }

public: // 

	CString m_mask;  // 
	CTopic* m_topic; // 

};
