/*   -

Copyright (c) 2001 - 2004. All Rights Reserved.
:  ..
*/
#include "Main.h"
#include "DB/Char/CharMob.h"

const int ZONE_ID           = 19;                //  
const int ZID               = ZONE_ID * 1000;
CZoneInstance* s_zoneInst = NULL;

//      -
int MobTrigger_19002( CMobTriggerData* data )
{
	if( data->m_type == MTRG_INCOMING_LEADER )
	{
		//  
		CIncomingLeaderMobTriggerData* incomingData = (CIncomingLeaderMobTriggerData*)data;

		//     
		if( incomingData->m_pulses == 0 )
		{
			g_trgMng.TriggerWait( 10, data );
			return 0;
		}
		if( incomingData->m_pulses == 10 )
		{
			incomingData->m_mob->ExecCmd( "" );
			g_trgMng.TriggerWait( 20, data );
			return 0;
		}
		if( incomingData->m_pulses == 30 )
		{
			incomingData->m_mob->ExecCmd( " !     ." );
			incomingData->m_mob->ExecCmd( "      ,   ." );
			incomingData->m_mob->ExecCmd( "   ,   ,   ." );
			incomingData->m_mob->ExecCmd( "           ." );
			incomingData->m_mob->ExecCmd( "   ,   ." );
			incomingData->m_mob->ExecCmd( "  !" );
		}
	}

	return 0;

}

//   
int PortalToSchoolTrigger( CObjTriggerData* data )
{
	//    - (       )
	if( data->m_type == OTRG_PORTAL )
	{
		//  
		CPortalObjTriggerData* portalData = (CPortalObjTriggerData*)data;

		//   
		if( portalData->m_char->realLevel() > 5 )
		{
			// 
			portalData->m_char->Send( "    ,         .\n" );

			//     
			portalData->m_toRoom = portalData->m_fromRoom;
			return 0;
		}

		return 0;
	}

	//  
	return 0;
}

//  
extern "C" void _declspec(dllexport) LoadTriggers( int instIdx )
{
	g_log.SystemLog( "Loading School.dll triggers..." );

	s_zoneInst = g_trgMng.m_inst = g_db.FindZoneInst( ZONE_ID, instIdx );

	//  
	g_trgMng.LoadMobTrigger( ZID+2, MTRG_INCOMING_LEADER, MobTrigger_19002 );

	//   
	g_trgMng.LoadObjTrigger( ZID+3, OTRG_PORTAL, PortalToSchoolTrigger );
}

//  
extern "C" void _declspec(dllexport) DeleteTriggers( int instIdx )
{
}

// 
extern "C" int _declspec(dllexport) Version()
{
	return APP_VERSION;
}
